//---------------------------------------------------------------------------

#ifndef RegexOptionsH
#define RegexOptionsH
//---------------------------------------------------------------------------

#include <vcl.h>
#include <vector>
#include <boost/shared_ptr.hpp>


class CRegexOption;
typedef std::vector<CRegexOption> CRegexOptionTable;

class CRegexOption
{
public:
	CRegexOption(int v, const wchar_t* s, const wchar_t* h);
	~CRegexOption();

public:
	boost::shared_ptr<TCheckBox> m_CheckBox;
	int m_Value;

public:
	static unsigned long makeFlags(const CRegexOptionTable& Tables);
	static UnicodeString makeFlagText(bool Prefix, const CRegexOptionTable& Tables);
};





#endif
