//---------------------------------------------------------------------------

#ifndef TfrmMainH
#define TfrmMainH
#include "JvCoolBar.hpp"
#include "JvExComCtrls.hpp"
#include "JvExStdCtrls.hpp"
#include "JvListView.hpp"
#include "JvRichEdit.hpp"
#include "JvTabBar.hpp"
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <Forms.hpp>
#include <ImgList.hpp>
#include <StdCtrls.hpp>
#include <ToolWin.hpp>

#include <memory>
#include <boost/regex.hpp>
#include "RegexOptions.h"

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE Ǘ̃R|[lg
	TStatusBar *StatusBar1;
	TPanel *Panel1;
	TJvRichEdit *redtResult;
	TPanel *Panel4;
	TJvTabBar *JvTabBar1;
	TPanel *Panel5;
	TSplitter *Splitter2;
	TSplitter *Splitter1;
	TPanel *Panel3;
	TComboBox *cboSyntax;
	TStaticText *StaticText1;
	TCategoryPanelGroup *CategoryPanelGroup1;
	TPanel *Panel2;
	TLabel *StaticText2;
	TJvCoolBar *JvCoolBar1;
	TToolBar *ToolBar1;
	TToolButton *btnClear;
	TToolButton *btnGo;
	TImageList *ImageList1;
	TToolBar *ToolBar2;
	TToolButton *btnClose;
	TCategoryPanel *CategoryPanel1;
	TCategoryPanel *CategoryPanel2;
	TButtonedEdit *edtRegex;
	TLabel *Label1;
	TMemo *Memo1;
	TLabel *Label2;
	TImageList *ImageList2;
	TLabeledEdit *edtLiteral;
	TLabel *Label3;
	TComboBox *cboOutputFormat;
	TToolButton *ToolButton1;
	TToolButton *btnCheck;
	TListView *lvwResult;
	TLabel *Label4;
	TCheckBox *chkMatchByLine;
	TComboBox *cboRegexType;
	TLabeledEdit *edtSyntaxOption;
	TLabeledEdit *edtMatchFlagType;
	TCheckBox *chkNameSpace;
	void __fastcall JvTabBar1TabSelected(TObject *Sender, TJvTabBarItem *Item);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall btnCheckClick(TObject *Sender);
	void __fastcall btnGoClick(TObject *Sender);
	void __fastcall btnCloseClick(TObject *Sender);
	void __fastcall btnClearClick(TObject *Sender);

private:	// [U[錾
	void __fastcall showItem(int Index);
	void __fastcall addOptions(TWinControl* p, CRegexOptionTable& t);
	boost::wregex __fastcall createRegex();
	int __fastcall doMatch(int Index, UnicodeString s, const boost::wregex& reg);
	int __fastcall doSearch(int Index, UnicodeString s, const boost::wregex& reg);
	int __fastcall doIterate(int Index, UnicodeString s, const boost::wregex& reg);

	int __fastcall addheader(int Index, UnicodeString s);
	void __fastcall addResult(int GroupID, int MatchIndex, const boost::wcmatch& m);


	int __fastcall addText(UnicodeString s);
	void __fastcall setTextColor(int Pos, const boost::wcmatch& m);
	TColor __fastcall getColor();

	int m_ColorIndex;
	CRegexOptionTable m_SyntaxOptions;
	CRegexOptionTable m_MatchFlags;
	std::vector<boost::regex_constants::match_flag_type> m_OutputFormats;

	// VXej[̃nhO
	void __fastcall OnSysCommand(TWMSysCommand& mess);
	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(WM_SYSCOMMAND, TWMSysCommand, OnSysCommand)
	END_MESSAGE_MAP(TForm)




public:		// [U[錾
	__fastcall TfrmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
