//---------------------------------------------------------------------------
#include <vcl.h>
#include <boost/array.hpp>
#include <boost/regex.hpp>
#include <boost/foreach.hpp>
#include <boost/preprocessor/wstringize.hpp>
#include <boost/preprocessor/seq/for_each.hpp>
#pragma hdrstop

#include "TfrmMain.h"
#include "TfrmAbout.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

#pragma link "JvExComCtrls"
#pragma link "JvExStdCtrls"
#pragma link "JvListView"
#pragma link "JvRichEdit"
#pragma link "JvTabBar"
#pragma link "JvToolBar"
#pragma link "JvCoolBar"
#pragma link "JvCoolBar"
#pragma link "JvExComCtrls"
#pragma link "JvExStdCtrls"
#pragma link "JvListView"
#pragma link "JvRichEdit"
#pragma link "JvTabBar"
#pragma link "JvCoolBar"
#pragma link "JvExComCtrls"
#pragma link "JvExStdCtrls"
#pragma link "JvListView"
#pragma link "JvRichEdit"
#pragma link "JvTabBar"
#pragma resource "*.dfm"

TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::JvTabBar1TabSelected(TObject *Sender, TJvTabBarItem *Item)
{
	//boost::regex_constants::syntax_option_type tt;
	showItem(Item->Index);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::showItem(int Index)
{
	if (Index == 0) {
		lvwResult->Visible = false;
		redtResult->Visible = true;
	} else {
		redtResult->Visible = false;
		lvwResult->Visible = true;
	}
}

//---------------------------------------------------------------------------

#if 0
#define SYNTAX_OPTS \
((icase 				,L"啶ʂȂ")) \
((nosubs 				,L"match_resultsɕ}b`i[Ȃ")) \
((optimize 				,L"K\}b`xDi_ł͉NȂj")) \
((collate 				,L"[a-b]`͈͂̕J[l")) \
((newline_alt			,L"su\\nvIZqƂĈ")) \
((no_mod_m 				,L"su^vAsu$v́As̒OAɃ}b`")) \
((no_mod_s 				,L"u.vsɃ}b`Ȃ")) \
((mod_s			 		,L"u.vsɃ}b`")) \
((mod_x 				,L"K̃GXP[vĂȂ󔒂𖳎")) \
((no_empty_expressions 	,L"̕ёI֎~")) \
((no_escape_in_lists 	,L"GXP[vʏ̕ƂĈ")) \
((no_bk_refs 			,L"QƂ𖳌ɂ")) \
((no_char_classes 		,L"NXw𖳌ɂ")) \
((no_intervals 			,L"EtJԂw𖳌ɂ")) \
((bk_plus_qm 			,L"u\\?v01̌JԂZqAu\\+v1ȏ̌JԂZqƂĈ")) \
((bk_vbar 				,L"u\\|IZqƂĈ"))
#else
#define SYNTAX_OPTS \
((icase 				,L"啶ʂȂ")) \
((nosubs 				,L"match_resultsɕ}b`i[Ȃ")) \
((optimize 				,L"K\}b`xDi_ł͉NȂj")) \
((collate 				,L"[a-b]`͈͂̕J[l")) \
((no_mod_m 				,L"su^vAsu$v́As̒OAɃ}b`")) \
((no_mod_s 				,L"u.vsɃ}b`Ȃ")) \
((mod_s			 		,L"u.vsɃ}b`")) \
((mod_x 				,L"K̃GXP[vĂȂ󔒂𖳎")) \
((no_escape_in_lists 	,L"GXP[vʏ̕ƂĈ")) \
((no_char_classes 		,L"NXw𖳌ɂ")) \
((no_intervals 			,L"EtJԂw𖳌ɂ")) \
((bk_plus_qm 			,L"u\\?v01̌JԂZqAu\\+v1ȏ̌JԂZqƂĈ")) \
((bk_vbar 				,L"u\\bvIZqƂĈ"))
#endif

#define MATCH_OPTS \
((match_default         ,L"ECMA Script̋Kɏ]ă}b`")) \
((match_not_bob         ,L"u\\AvAu\\`v𕶎̐擪Ƀ}b`Ȃ")) \
((match_not_eob         ,L"u\\'vAu\\zvAu\\Zv𕶎̏I[Ƀ}b`Ȃ")) \
((match_not_bol         ,L"u^v𕶎擪Ƀ}b`Ȃ")) \
((match_not_eol         ,L"u$v𕶎I[Ƀ}b`Ȃ")) \
((match_not_bow         ,L"u\\<vAu\\bv𕶎擪Ƀ}b`Ȃ")) \
((match_not_eow         ,L"u\\>vAu\\bv𕶎I[Ƀ}b`Ȃ")) \
((match_any             ,L"̃}b`΁AׂĂʂƌȂ")) \
((match_not_null        ,L"̃V[PXɃ}b`Ȃ")) \
((match_continuous      ,L"}b`͐擪Jn")) \
((match_partial         ,L"vԂ")) \
((match_extra           ,L"LȃLv`ׂĊi[")) \
((match_single_line     ,L"su^vAsu$vAs̒OAɃ}b`Ȃ")) \
((match_prev_avail      ,L"--first@ȃCe[^ʒuł邱Ƃw肷")) \
((match_not_dot_newline	,L"u.vsɃ}b`Ȃ")) \
((match_not_dot_null    ,L"u.vNULLɃ}b`Ȃ")) \
((match_posix           ,L"POSIX̍ōKɂĎ̃}b`s")) \
((match_perl            ,L"Perl̃}b`KɂĎ̃}b`s")) \
((match_nosubs          ,L"Lv`O[v𖳎")) \

///((match_results         ,L"NXɂ̓}b`ŜɊւ̂݊܂܂AɂĂ͋L^Ȃ"))


#define ADD_OPT(r, t, v) \
	t.push_back(CRegexOption( \
				BOOST_PP_TUPLE_ELEM(2, 0, v), \
				BOOST_PP_WSTRINGIZE(BOOST_PP_TUPLE_ELEM(2, 0, v)), \
				BOOST_PP_TUPLE_ELEM(2, 1, v) \
				));

#define FORMAT_TYPES \
(format_default) \
(format_sed) \
(format_perl) \
(format_literal) \
(format_no_copy) \
(format_first_only) \
(format_all)

#define ADD_ITEM(r, t, v) \
  BOOST_PP_TUPLE_ELEM(2, 0, t).push_back(v); \
  BOOST_PP_TUPLE_ELEM(2, 1, t)->Items->Add(BOOST_PP_WSTRINGIZE(v));


const int ID_MENUITEM_ABOUT = 128;

void __fastcall TfrmMain::FormCreate(TObject *Sender)
{

	// fAtHg[h𖳌ɂ
	DWORD dwLangOptions = SendMessage(redtResult->Handle, EM_GETLANGOPTIONS, 0, 0);
	dwLangOptions &= ~IMF_DUALFONT;
	SendMessage(redtResult->Handle, EM_SETLANGOPTIONS, 0, (LPARAM)dwLangOptions);

	// VXej[̒ǉ
    HMENU hMenu = GetSystemMenu(Handle, FALSE);
	AppendMenu(hMenu, MF_SEPARATOR,0, NULL);
	AppendMenu(hMenu, MF_STRING, ID_MENUITEM_ABOUT, _T("About..."));

	// K\IvV̏ݒ
	int sel = 0;
	JvTabBar1->Tabs->Items[sel]->Selected = true;
	showItem(sel);

	using namespace boost::regex_constants;

	m_SyntaxOptions.clear();
	BOOST_PP_SEQ_FOR_EACH(ADD_OPT, m_SyntaxOptions, SYNTAX_OPTS);
	CategoryPanel1->Collapsed = false;
	addOptions(CategoryPanel1, m_SyntaxOptions);

	m_MatchFlags.clear();
	BOOST_PP_SEQ_FOR_EACH(ADD_OPT, m_MatchFlags, MATCH_OPTS);
	CategoryPanel2->Collapsed = false;
	addOptions(CategoryPanel2, m_MatchFlags);

	CategoryPanel1->Collapsed = true;
	CategoryPanel2->Collapsed = true;

	cboOutputFormat->Clear();
	BOOST_PP_SEQ_FOR_EACH(ADD_ITEM, (m_OutputFormats, cboOutputFormat), FORMAT_TYPES);
	cboOutputFormat->ItemIndex = 0;

	cboRegexType->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall  TfrmMain::OnSysCommand(TWMSysCommand& mess)
{
	if (mess.CmdType == ID_MENUITEM_ABOUT) {
		frmAbout->ShowModal();
	} else {
		// ftHgj[̏
		TForm::Dispatch(&mess);
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::addOptions(TWinControl* p, CRegexOptionTable& t)
{
	int yy = 0;
	BOOST_FOREACH(CRegexOption& i, t) {
		i.m_CheckBox->Parent = p;
		i.m_CheckBox->Width = 256;
		i.m_CheckBox->Top = yy;
		yy += 21;
	}
	yy += 21;
	p->Height = yy;
}

//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnCheckClick(TObject *Sender)
{
	try {
		boost::wregex reg = createRegex();
		ShowMessage(_T("Regex is OK!"));
	} catch (boost::regex_error& ex) {
		UnicodeString mess;
		UnicodeString what(ex.what());
		mess.printf(_T("Error:%d \"%s\""), ex.code(), what.t_str());
		ShowMessage(mess);
	}
}

//---------------------------------------------------------------------------

boost::wregex __fastcall TfrmMain::createRegex()
{
	boost::regex::flag_type Option = CRegexOption::makeFlags(m_SyntaxOptions);

	switch (cboSyntax->ItemIndex) {
		case 1:		// POSIX{
			Option |= boost::regex::basic;
		break;
		case 2:		// POSIXg
			Option |= boost::regex::extended;
		break;
		default:    // Perl݊
		break;
	}

	boost::wregex reg(edtRegex->Text.c_str(), Option);

	return reg;
}

//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnGoClick(TObject *Sender)
{
	try {
		boost::wregex reg = createRegex();

		boost::wcmatch::iterator iter;
		int Count;

		redtResult->Clear();
		lvwResult->Clear();
		lvwResult->Groups->Clear();
		m_ColorIndex = 0;
		edtLiteral->Text = _T("");
		edtSyntaxOption->Text = _T("");
		edtMatchFlagType->Text = _T("");

		int _fastcall (__closure *mf)(int Index, UnicodeString s, const boost::wregex& reg);

		switch (cboRegexType->ItemIndex) {
			case 1:
				mf = doSearch;
			break;
			case 2:
				mf = doMatch;
			break;
			default:
				mf = doIterate;
			break;
		}

		if (chkMatchByLine->Checked) {
			int Matched = 0;
			for (int i = 0; i < Memo1->Lines->Count; ++i) {
				Count = mf(i, Memo1->Lines->Strings[i], reg);
				if (Count) ++Matched;
			}
			StatusBar1->SimplePanel = true;

			StatusBar1->SimpleText = UnicodeString().sprintf(_T("%ds}b`܂B"), Matched);
		} else {
			// CR͏O
			UnicodeString s0 =Strutils::ReplaceStr(Memo1->Lines->Text, _T("\r"), _T(""));
			Count = mf(0, s0, reg);
			if (Count > 0) {
				StatusBar1->SimplePanel = true;
				StatusBar1->SimpleText = _T("}b`܂B");
			} else {
				StatusBar1->SimplePanel = true;
				StatusBar1->SimpleText = _T("}b`܂łB");
			}
		}

		// C/C++e̐
		UnicodeString tx = edtRegex->Text;
		static UnicodeString qs[] = {_T("\\"),  _T("?"), _T("\""), _T("\'")};
		for (int i = 0; i < 4; ++i) {
			UnicodeString r = _T("\\") + qs[i];
			tx = StringReplace(tx, qs[i], r, TReplaceFlags() <<  rfReplaceAll);
		}
		tx = QuotedString(tx, _T('\"'));
		edtLiteral->Text = _T("_T(") + tx + _T(")");

		// IvV
		edtSyntaxOption->Text = CRegexOption::makeFlagText(chkNameSpace->Checked, m_SyntaxOptions);
		edtMatchFlagType->Text = CRegexOption::makeFlagText(chkNameSpace->Checked, m_MatchFlags);
	} catch (boost::regex_error& ex) {
		UnicodeString mess;
		UnicodeString what(ex.what());
		mess.printf(_T("Error:%d \"%s\""), ex.code(), what.t_str());
		ShowMessage(mess);
	}
}
//---------------------------------------------------------------------------

int __fastcall TfrmMain::doSearch(int Index, UnicodeString s, const boost::wregex& reg)
{
	boost::wcmatch m;
	boost::match_flag_type flags = CRegexOption::makeFlags(m_MatchFlags);

	bool ret = regex_search(s.c_str(), m, reg, flags);

	int Pos = addText(s);

	if (ret) {
		int GroupID = addheader(Index, s);
		addResult(GroupID, 0, m);
		setTextColor(Pos, m);
	}

	return ret ? 1 : 0;
}
//---------------------------------------------------------------------------

int __fastcall TfrmMain::doMatch(int Index, UnicodeString s, const boost::wregex& reg)
{
	boost::wcmatch m;
	boost::match_flag_type flags = CRegexOption::makeFlags(m_MatchFlags);

	bool ret = regex_match(s.c_str(), m, reg);

	int Pos = addText(s);

	if (ret) {
		int GroupID = addheader(Index, s);
		addResult(GroupID, 0, m);
		setTextColor(Pos, m);
	}

	return ret ? 1 : 0;
}
//---------------------------------------------------------------------------

int __fastcall TfrmMain::doIterate(int Index, UnicodeString s, const boost::wregex& reg)
{

	boost::match_flag_type flags = CRegexOption::makeFlags(m_MatchFlags);

	wchar_t *b = s.c_str();
	wchar_t *e = b + s.Length();

	int Co = 0;
	boost::wcregex_iterator iter(b, e, reg, flags);
	boost::wcregex_iterator last;

	int Pos = addText(s);

	bool ret = false;
	int GroupID = addheader(Index, s);
	while (iter != last) {
		addResult(GroupID, Co, *iter);
		setTextColor(Pos, *iter);
		++iter;
		ret = true;
		++Co;
	}

	return Co;
}
//---------------------------------------------------------------------------


int __fastcall TfrmMain::addheader(int Index, UnicodeString s)
{
	TListGroups *grps = lvwResult->Groups;
	int GroupID = -1;

	if (Index >= 0) {
		TListGroup *gr = grps->Add();

		GroupID = Index + 1;
		gr->GroupID = GroupID;
		UnicodeString Header = UnicodeString::Format(_T("Line:%d (%s)"), ARRAYOFCONST((Index, s)));
		gr->Header = Header;
		gr->State = TListGroupStateSet() << lgsNormal << lgsCollapsible;
	}

	return GroupID;
}

void __fastcall TfrmMain::addResult(int GroupID, int MatchIndex, const boost::wcmatch& m)
{
	int sz = (int)m.size();
	for (int i = 0; i < sz; ++i) {
		// ListViewɒǉ
		TListItem* pItem = lvwResult->Items->Add();
		pItem->GroupID = GroupID;
		pItem->Caption = UnicodeString().sprintf(_T("%d-%d"), MatchIndex, i);
		pItem->SubItems->Add(m.str(i).c_str());
		pItem->SubItems->Add(UnicodeString(m.position(i)));
		pItem->SubItems->Add(UnicodeString(m.length(i)));
		pItem->SubItems->Add(BoolToStr(m[i].matched, true));
	}
}

//---------------------------------------------------------------------------

int __fastcall TfrmMain::addText(UnicodeString s)
{
	// ǉ
	int p = redtResult->Text.Length();
	if (p) {
		redtResult->SelStart = p;
		redtResult->SelLength = 0;
		redtResult->SelText = _T("\n");
	}

	if (chkMatchByLine->Checked) {
		p = redtResult->Text.Length() - redtResult->Lines->Count;  // CR/LFl
	} else {
		p = redtResult->Text.Length();
	}
	redtResult->SelStart = p;
	redtResult->SelLength = 0;
	redtResult->SelText = s;

	return p;
}

//---------------------------------------------------------------------------

void __fastcall TfrmMain::setTextColor(int Pos, const boost::wcmatch& m)
{
	int size = (int)m.size();
	if (size == 0) return;

	// }b`̐Fݒ
	TColor Color = getColor();
	redtResult->SelStart = Pos + m.position(0);
	redtResult->SelLength = m.length(0);
	redtResult->SelAttributes->BackColor = Color;

	//
	for (int i = 1; i < size; ++i) {
		redtResult->SelStart = Pos + m.position(i);
		redtResult->SelLength = m.length(i);
		redtResult->SelAttributes->UnderlineType =  (i % 2) ?  utSolid : utWave;
		redtResult->SelAttributes->Underline = true;
	}
}

//---------------------------------------------------------------------------

TColor __fastcall TfrmMain::getColor()
{
	const int ColCount = 7;
	static long Colors[] = {
		0x00FFB2D9, 0x00FFF799, 0x007FFF91, 0x00B2FFFF,
		0x00FFBF7F, 0x00CCCCFF, 0x00BFFF33
	};

	TColor Color = (TColor)Colors[m_ColorIndex];
	m_ColorIndex++;

	if (m_ColorIndex >= ColCount) m_ColorIndex = 0;

	return Color;
}
void __fastcall TfrmMain::btnCloseClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnClearClick(TObject *Sender)
{
	edtRegex->Text = _T("");
	Memo1->Clear();
	edtLiteral->Text = _T("");
	redtResult->Clear();
	lvwResult->Clear();
	m_ColorIndex = 0;
	edtSyntaxOption->Text = _T("");
	edtMatchFlagType->Text = _T("");
}
//---------------------------------------------------------------------------

